#pragma once

#include <Windows.h>
#include <tchar.h>
#include <cassert>

typedef LRESULT (CALLBACK *WindowProcPtrType)( HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

void SetWindowProc(HWND hwnd,WindowProcPtrType NewWndProc,WindowProcPtrType& PrevWndProc);

HWND CreateMessageOnlyWindow();

void InvokeMessagePump();

template<typename ClassType,typename InterfaceType>
InterfaceType* CreateInstance()
{
  InterfaceType* Ptr;
  const HRESULT st = CoCreateInstance
  (
    __uuidof(ClassType),
    NULL,CLSCTX_INPROC_SERVER,
    __uuidof(InterfaceType),
    (void**)&Ptr
  );
  if ( st != S_OK ) {
    if ( st == REGDB_E_CLASSNOTREG ) {
      _tprintf(_T("Object is not found in system.\n"));
      assert(false);
    }
  }
  if ( !Ptr ) {
    _tprintf(_T("Can't create object. st=%x\n"),st);
  }
  return Ptr;
}

#define MUST_SUCCESS(hr) if ( hr != S_OK ) { assert(false); }