// TestBecomingReady.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#define INITGUID
#include <Windows.h>
#include <Ioevent.h>
#include "Helpers.h"
#include <tchar.h>
#include <Dbt.h>

#include <cassert>
#include <imapi2.h>
#include <imapi2error.h>

#include <string>


HRESULT hr;
HWND g_hMainWindow;
WindowProcPtrType g_PrevProc;


UINT_PTR g_TimerId;
WPARAM g_TimerId_ = 0x20;

HANDLE g_hDevice = INVALID_HANDLE_VALUE;
HANDLE g_hDevice2 = INVALID_HANDLE_VALUE;
HDEVNOTIFY g_hNotify2;

IDiscRecorder2* g_pRecorder;
IDiscFormat2Data* g_pDiscFormat2Data;
HRESULT g_LastBecomingReady;

std::wstring g_DeviceId;


void OnTimer()
{
  //_tprintf(_T("%s %d\n"),_T(__FUNCTION__),__LINE__);
  
  if ( false ) {
    DWORD bytes_returned = 0;
    _tprintf(_T("DeviceIoControl -> "));
    BOOL res = DeviceIoControl(g_hDevice, IOCTL_STORAGE_CHECK_VERIFY2, NULL, 0, NULL, 0, &bytes_returned, NULL);
    _tprintf(_T("res=%d\n"),res);
  }
  if ( true ) {
    IMAPI_FORMAT2_DATA_MEDIA_STATE dummy;
    hr = g_pDiscFormat2Data->get_CurrentMediaStatus(&dummy);
    //_tprintf(_T("CurrentMediaStatus hr=%x\n"),hr);
    bool Print = false;
    if ( g_LastBecomingReady != hr ) {
      g_LastBecomingReady = hr;
      Print = true;
    }
    if ( Print ) {
      if ( g_LastBecomingReady == E_IMAPI_RECORDER_MEDIA_BECOMING_READY ) {
        _tprintf(_T("MEDIA_BECOMING_READY=YES\n"));
      }
      else {
        _tprintf(_T("MEDIA_BECOMING_READY=NO\n"));
      }
    }
  }
}

LRESULT CALLBACK WindowProc( HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
  switch(uMsg) {
  case WM_CREATE:
    break;
  case WM_TIMER:
    if ( hwnd == g_hMainWindow && g_TimerId_ == wParam) {
      OnTimer();
    }
    break;
  case WM_DEVICECHANGE: {
    _tprintf(_T("WM_DEVICECHANGE -> "));
    if ( wParam == DBT_CUSTOMEVENT ) {
      _tprintf(_T("DBT_CUSTOMEVENT -> "));
      if ( reinterpret_cast<DEV_BROADCAST_HDR*>(lParam)->dbch_devicetype == DBT_DEVTYP_HANDLE ) {
        DEV_BROADCAST_HANDLE* pEv = reinterpret_cast<DEV_BROADCAST_HANDLE*>(lParam);
        _tprintf(_T("DEV_BROADCAST_HANDLE -> "));
        if ( IsEqualGUID(GUID_IO_MEDIA_ARRIVAL,pEv->dbch_eventguid) ) {
          _tprintf(_T("GUID_IO_MEDIA_ARRIVAL"));
        }
        else if (IsEqualGUID(GUID_IO_MEDIA_REMOVAL,pEv->dbch_eventguid)) {
          _tprintf(_T("GUID_IO_MEDIA_REMOVAL"));
        }
        else if (IsEqualGUID(GUID_IO_VOLUME_MOUNT,pEv->dbch_eventguid)) {
          _tprintf(_T("GUID_IO_VOLUME_MOUNT"));
        }
        else if (IsEqualGUID(GUID_IO_DEVICE_BECOMING_READY,pEv->dbch_eventguid)) {
          _tprintf(_T("GUID_IO_DEVICE_BECOMING_READY"));
        }
        else {
          _tprintf(_T("unknown %d"),__LINE__);
        }
      }
      else {
        _tprintf(_T("unknown %d"),__LINE__);
      }
    }
    else if ( wParam == DBT_DEVICEREMOVECOMPLETE ) {
      _tprintf(_T("DBT_DEVICEREMOVECOMPLETE"));
    }
    else if ( wParam == DBT_DEVICEARRIVAL ) {
      _tprintf(_T("DBT_DEVICEARRIVAL -> "));
      if ( reinterpret_cast<DEV_BROADCAST_HDR*>(lParam)->dbch_devicetype == DBT_DEVTYP_HANDLE ) {
        _tprintf(_T("DBT_DEVTYP_HANDLE"));
      }
      else if ( reinterpret_cast<DEV_BROADCAST_HDR*>(lParam)->dbch_devicetype == DBT_DEVTYP_VOLUME ) {
        _tprintf(_T("DBT_DEVTYP_VOLUME -> "));
        DEV_BROADCAST_VOLUME* pEv = reinterpret_cast<DEV_BROADCAST_VOLUME*>(lParam);
        if ( pEv->dbcv_flags & DBTF_MEDIA ) {
          _tprintf(_T("DBTF_MEDIA"));
        }
        else {
          _tprintf(_T("unknown %d"),__LINE__);
        }
      }
      else {
        _tprintf(_T("unknown %d"),__LINE__);
      }
    }
    else {
      _tprintf(_T("unknown %d"),__LINE__);
    }
    _tprintf(_T("\n"));
    break;
                        }
  default:;
  }
  if ( g_PrevProc ) {
    return CallWindowProc(g_PrevProc,hwnd,uMsg,wParam,lParam);
  }
  else {
    return DefWindowProc(hwnd,uMsg,wParam,lParam);
  }
}

std::wstring GetDeviceId()
{
  IDiscMaster2* pDiskMaster = CreateInstance<MsftDiscMaster2,IDiscMaster2>();
    
  IEnumVARIANT* pEnumVariant;
  hr = pDiskMaster->get__NewEnum(&pEnumVariant); MUST_SUCCESS(hr);
  hr = pEnumVariant->Reset(); MUST_SUCCESS(hr);
  VARIANT Var;
  //_tprintf(_T("Devices:\n"));
  std::wstring result;
  for( ULONG i=0; pEnumVariant->Next(1,&Var,&i) == S_OK; ++i ) {
     result = Var.bstrVal;
    //_tprintf(_T("%s\n"),result.c_str());
  }
  //----
  // you can overide result here
  result = _T("\\\\?\\ide#cdromtsstcorp_cddvdw_ts-l633a________________as03____#5&212df567&0&2.0.0#{53f56308-b6bf-11d0-94f2-00a0c91efb8b}");
  //----
  _tprintf(_T("Selected device: %s\n"),result.c_str());
  return result;
}

int _tmain(int argc, _TCHAR* argv[])
{
  const HRESULT st = CoInitializeEx(NULL,COINIT_APARTMENTTHREADED);
  assert( st == S_OK || st == S_FALSE );

  g_DeviceId = GetDeviceId();

  g_hMainWindow = CreateMessageOnlyWindow();
  SetWindowProc(g_hMainWindow,&WindowProc,g_PrevProc);
  g_TimerId = SetTimer(g_hMainWindow,g_TimerId_,100,NULL);
  assert(g_TimerId != 0);

  {
    //g_hDevice = CreateFile (g_DeviceId, FILE_READ_ATTRIBUTES, 0, NULL, OPEN_EXISTING, 0, NULL);
   // assert( g_hDevice != INVALID_HANDLE_VALUE );
  }
  g_hDevice2 = ::CreateFile(g_DeviceId.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
  assert(g_hDevice2 != INVALID_HANDLE_VALUE);

  if ( true ) {
    DEV_BROADCAST_HANDLE dbh={};
    dbh.dbch_size = sizeof(dbh);
    dbh.dbch_devicetype = DBT_DEVTYP_HANDLE;
    dbh.dbch_handle = g_hDevice2;
    g_hNotify2 = RegisterDeviceNotification( g_hMainWindow, &dbh, DEVICE_NOTIFY_WINDOW_HANDLE);
    assert( g_hNotify2 != NULL );
  }
  if ( true ) {
    g_pRecorder = CreateInstance<MsftDiscRecorder2,IDiscRecorder2>();
    BSTR str = SysAllocStringLen( g_DeviceId.c_str(), g_DeviceId.size());
    hr = g_pRecorder->InitializeDiscRecorder(str); MUST_SUCCESS(hr);

    g_pDiscFormat2Data = CreateInstance<MsftDiscFormat2Data,IDiscFormat2Data>();
    hr = g_pDiscFormat2Data->put_Recorder(g_pRecorder); MUST_SUCCESS(hr);
  }

  InvokeMessagePump();

	return 0;
}

